package main

import (
	"fmt"
	"github.com/charmbracelet/log"
	xflags "gitlab.schukai.com/oss/libraries/go/application/xflags.git"

	"os"
)

func main() {

	var settings *xflags.Settings[Definition]

	definition := Definition{}
	definition.Template.Prepare.DataFile = "data.yaml"

	logger := log.Default()
	logger.SetLevel(log.ErrorLevel)

	settings = xflags.New(os.Args[0], definition)
	settings.Parse(os.Args[1:])

	if settings.GetValues().Verbose {
		logger.SetLevel(log.DebugLevel)
	}

	settings.Execute()

	if settings.HasErrors() {
		for _, err := range settings.Errors() {
			fmt.Println(err)
		}

		os.Exit(1)
	} else {
		if settings.WasExecuted() {
			os.Exit(0)
		}
		os.Exit(1)
	}

}
